#include<iostream>
#include<cmath>

using namespace std;

#define maxi 10000000
#define div 820
#define endl "\n"

long long primes[665000],cnt;
long long sumOne[665000],cntOne[665000];
long long sumPrimes[div+10],cntPrimes[div+10];
bool b[maxi+2];

long long findIndex(long long x)
{
    long long l,r,mid;

    l=0;
    r=cnt-1;

    while(r>l)
    {
        mid=(l+r)/2;

        if(primes[mid]==x)
            return mid;
        if(primes[mid]>x)
            r=mid-1;
        else
            l=mid+1;
    }

    if(primes[l]==x)
        return l;
    return -1;
}

long long findIndexR(long long x)
{
    long long l,r,mid;

    l=0;
    r=cnt-1;

    while(r>l)
    {
        mid=(l+r+1)/2;

        if(primes[mid]==x)
            return mid;
        if(primes[mid]>x)
            r=mid-1;
        else
            l=mid;
    }

    return l;
}

long long findIndexL(long long x)
{
    long long l,r,mid;

    l=0;
    r=cnt-1;

    while(r>l)
    {
        mid=(l+r)/2;

        if(primes[mid]==x)
            return mid;
        if(primes[mid]>x)
            r=mid;
        else
            l=mid+1;
    }

    return l;
}

pair<long long,long long> findNextNumber(string s,long long ind)
{
    long long i,res=0,n=s.size();

    for(i=ind;i<n && s[i]!=' ';i++)
    {
        res*=10;
        res+=(long long)s[i]-'0';
    }

    return make_pair(res,i);
}

int main ()
{
    long long i,j,x,y,t,t2,r,r2;
    long long f1,f2;
    pair<long long,long long> p;
    string s;

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    for(i=2;i<=maxi;i++)
    {
        if(b[i])continue;

        primes[cnt]=i;
        cnt++;
        for(j=i;j<=maxi;j+=i)
            b[j]=1;
    }

    while(getline(cin,s))
    {
        if(s[0]=='a')
        {
            p=findNextNumber(s,2);
            x=p.first;
            t=findIndex(x);
            //cout<<t<<endl;
            if(t==-1)
                continue;

            sumOne[t]+=x;
            cntOne[t]++;
            sumPrimes[t/div]+=x;
            cntPrimes[t/div]++;
        }
        else
        {
            if(s[0]=='d')
            {
                p=findNextNumber(s,2);
                x=p.first;
                t=findIndex(x);
                if(t==-1)
                    continue;

                if(cntOne[t])
                {
                   sumOne[t]-=x;
                    cntOne[t]--;
                    sumPrimes[t/div]-=x;
                    cntPrimes[t/div]--;
                }
            }
            else
            {
                p=findNextNumber(s,2);
                x=p.first;
                p=findNextNumber(s,p.second+1);
                y=p.first;

                t=findIndexL(x);
                t2=findIndexR(y);

                if(t>t2)
                {
                    cout<<"0 0"<<endl;
                    continue;
                }
                r=t/div;
                r2=t2/div;

                f1=0;
                f2=0;

                if(r==r2)
                {
                    for(i=t;i<=t2;i++)
                    {
                        f1+=cntOne[i];
                        f2+=sumOne[i];
                    }

                    cout<<f1<<" "<<f2<<endl;
                    continue;
                }

                for(i=t;i<(r+1)*div;i++)
                {
                    f1+=cntOne[i];
                    f2+=sumOne[i];
                }
                for(i=t2;i>=(r2)*div;i--)
                {
                    f1+=cntOne[i];
                    f2+=sumOne[i];
                }
                for(i=r+1;i<r2;i++)
                {
                    f1+=cntPrimes[i];
                    f2+=sumPrimes[i];
                }

                cout<<f1<<" "<<f2<<endl;
            }
        }
    }

    return 0;
}
