#include<iostream>
int sum[10000000];
int cnt[10000000];
int isPrime[10000000];
int n=10000000;
void addSum(int ind)
{
    int num=ind;
    while(ind<=n)
    {
        sum[ind]+=num;
        ind+=ind&(-ind);
    }
}
void subSum(int ind)
{
    int num=ind;
    while(ind<=n)
    {
        sum[ind]-=num;
        ind+=ind&(-ind);
    }
}
long long totSum(int ind)
{
    long long res=0;
    while(ind>0)
    {
        res+=sum[ind];
        ind-=ind&(-ind);
    }
    return res;
}
void addCnt(int ind)
{
    while(ind<=n)
    {
        cnt[ind]++;
        ind+=ind&(-ind);
    }
}
void subCnt(int ind)
{
    while(ind<=n)
    {
        cnt[ind]--;
        ind+=ind&(-ind);
    }
}
long long totCnt(int ind)
{
    long long res=0;
    while(ind>0)
    {
        res+=cnt[ind];
        ind-=ind&(-ind);
    }
    return res;
}
int main()
{
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);
    char command;
    int a,b;
    while(std::cin>>command)
    {
        if(command=='c')
        {
            std::cin>>a>>b;
            std::cout<<totCnt(b)-totCnt(a-1)<<" "<<totSum(b)-totSum(a-1)<<"\n";
        }
        if(command=='a')
        {
            std::cin>>a;
            if(isPrime[a]==0)
            {
                int prime=1;
                if(a==1)
                {
                    prime=0;
                }
                for(int i=2; i*i<=a; i++)
                {
                    if(a%i==0)
                    {
                        prime=0;
                        break;
                    }
                }
                isPrime[a]=prime+1;
            }
            if(isPrime[a]==2)
            {
                addSum(a);
                addCnt(a);
            }
        }
        if(command=='d')
        {
            std::cin>>a;
            if(isPrime[a]==0)
            {
                int prime=1;
                if(a==1)
                {
                    prime=0;
                }
                for(int i=2; i*i<=a; i++)
                {
                    if(a%i==0)
                    {
                        prime=0;
                        break;
                    }
                }
                isPrime[a]=prime+1;
            }
            if(isPrime[a]==2 && totCnt(a)-totCnt(a-1)>0)
            {
                subSum(a);
                subCnt(a);
            }
        }
    }
    std::cout.flush();
    return 0;
}
