#include<iostream>
int sum[10000002];
int cnt[10000002];
bool eratosten[10000002];
int n=10000001;
void addSum(int ind)
{
    int num=ind;
    while(ind<=n)
    {
        sum[ind]+=num;
        ind+=ind&(-ind);
    }
}
void subSum(int ind)
{
    int num=ind;
    while(ind<=n)
    {
        sum[ind]-=num;
        ind+=ind&(-ind);
    }
}
long long totSum(int ind)
{
    long long res=0;
    while(ind>0)
    {
        res+=sum[ind];
        ind-=ind&(-ind);
    }
    return res;
}
void addCnt(int ind)
{
    while(ind<=n)
    {
        cnt[ind]++;
        ind+=ind&(-ind);
    }
}
void subCnt(int ind)
{
    while(ind<=n)
    {
        cnt[ind]--;
        ind+=ind&(-ind);
    }
}
long long totCnt(int ind)
{
    long long res=0;
    while(ind>0)
    {
        res+=cnt[ind];
        ind-=ind&(-ind);
    }
    return res;
}
int main()
{
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);
    eratosten[1]=1;
    for(int i=2;i<n;i++){
        if(!eratosten[i]){
            for(int j=i+i;j<n;j+=i){
                eratosten[j]=1;
            }
        }
    }
    char command;
    int a,b;
    while(std::cin>>command)
    {
        if(command=='c')
        {
            std::cin>>a>>b;
            std::cout<<totCnt(b)-totCnt(a-1)<<" "<<totSum(b)-totSum(a-1)<<"\n";
        }
        if(command=='a')
        {
            std::cin>>a;
            if(eratosten[a]==0)
            {
                addSum(a);
                addCnt(a);
            }
        }
        if(command=='d')
        {
            std::cin>>a;
            if(eratosten[a]==0 && totCnt(a)-totCnt(a-1)>0)
            {
                subSum(a);
                subCnt(a);
            }
        }
    }
    std::cout.flush();
    return 0;
}
