#include <iostream>
#include <vector>
using namespace std;
long long d[10000000];
//bool pr1me[10000000];
vector <pair <long long, long long> > ans;

bool prime(long long x)
{
    if (x == 1)
        return false;
    for (long long i = 2; i * i <= x; i++)
        if (x % i == 0)
            return false;
    return true;
}

void query(long long x, long long y, long long &a, unsigned long long &b)
{
    a = 0;
    b = 0;
    for (long long i = x; i <= y; i++)
    {
        if (prime(i))
        {
            //if (d[i] > 0)a += d[i];
            a += d[i];
            //cout <<  " * " << d[i] << " * " << a << endl;
            //r = r + d[i];
            b += i * d[i];
        }
    }
    //a = r;

}

void input()
{
    char c;
    long long x, y;
    long long temp_max = 0;
    while (cin >> c)
    {
        if (c == 'a')
        {
            cin >> x;
            temp_max = max(x, temp_max);
            d[x]++;
            /// add number
        }
        else if (c == 'd')
        {
            cin >> x;
            if (d[x] > 0)
                d[x]--;
            /// delete number
        }
        else if (c == 'c')
        {
            cin >> x >> y;
            /// query
            long long a;
            unsigned long long b;
            if (y < temp_max)
                query(x, y, a, b);
            else
                query(x, temp_max, a, b);
            //cout << a << endl;
            pair <long long, unsigned long long> p;
            p.first = a;
            p.second = b;
            ans.push_back(p);
        }
    }
}

void output()
{
    for (long long i = 0; i < ans.size(); i++)
    {
        cout << ans[i].first << " " << ans[i].second << endl;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    input();
    output();

    return 0;

}
/*
a 1
a 5
c 5 5
a 4
c 1 50
a 3
d 5
a 7
a 6
a 7
c 3 8
a 10
a 11
a 12
c 8 12
d 11
c 7 11
d 7
d 7
d 7
c 1 100
c 100 200
*/
