#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> inline void chkmax(T &x, const T1 &y) { if (x < y) x = y; }
template<class T, class T1> inline void chkmin(T &x, const T1 &y) { if (x > y) x = y; }

multiset<int> bag;

bool is_simple(int x)
{
    if (x < 2)
        return false;
    if (x == 2)
        return true;
    if (!(x & 1))
        return false;
    for (int i = 2; i * i <= x; i++)
        if (x % i == 0)
            return false;
    return true;
}

void solve()
{
    multiset<int>::iterator it;
    bag.clear();
    char ch;
    while (cin >> ch)
    {
        if (ch == 'a')
        {
            int x;
            cin >> x;
            bag.insert(x);
        }
        else if (ch == 'd')
        {
            int x;
            cin >> x;
            if (bag.count(x) > 0)
                bag.erase(bag.lower_bound(x));
        }
        else
        {
            int x, y;
            cin >> x >> y;
            int cnt = 0, sum = 0;
            for (it = bag.lower_bound(x); it != bag.end(); it++)
            {
                int val = *it;
                if (val > y)
                    break;
                if ((val >= x) && (is_simple(val)))
                {
                    cnt++;
                    sum += val;
                }
            }
            cout << cnt << ' ' << sum << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    solve();

    return EXIT_SUCCESS;
}
