#include <iostream>
using namespace std;
int n, m, a [2048], b [2048], block [2048], sums1 [2048], sums2 [2048];
bool tree [10000];
void upd (int l, int r, int pos, int x){
    if (l == r){
        tree [pos] = !tree [pos];
        return;
    }
    int mid = (l + r) / 2;
    if (x <= mid) upd (l, mid, 2 * pos, x);
    else upd (mid + 1, r, 2 * pos + 1, x);
    tree [pos] = tree[2 * pos] || tree [2 * pos + 1];
}
bool query (int l, int r, int pos, int ql, int qr){
    if (l > qr || r < ql) return 0;
    if (l >= ql && r <= qr) return tree [pos];
    int mid = (l + r) / 2;
    return query (l, mid, 2 * pos, ql, qr) || query (mid + 1, r, 2 * pos + 1, ql, qr);
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (nullptr);
    cin >> n >> m;
    for (int i = 0; i < n; i ++) cin >> a [i];
    for (int j = 0; j < m; j ++) cin >> b [j];
    if (m == 1 && n == 1 && a [0] == b [0]){
        cout << "0\n";
        return 0;
    }
    for (int i = 0; i < n; i ++){
        block [i] = m;
        for (int j = 0; j < m; j ++){
            if (a [i] == b [j]) block [i] = j;
        }
    }
    for (int i = 1; i <= n; i ++) sums1 [i] = sums1 [i - 1] + a [i - 1];
    for (int i = 1; i <= m; i ++) sums2 [i] = sums2 [i - 1] + b [i - 1];
    int l = 1, r = min (m, n);
    while (l <= r){
        for (int i = 0; i < 9500; i ++) tree [i] = 0;
        int mid = (l + r + 1) / 2, k = mid;
        for (int i = 0; i < k; i ++){
            if (block [i] < m){
                upd (0, m - 1, 1, block [i]);
            }
        }

        int ans = 0, l1 = 100000, l2 = 100000;
        for (int i = 0; i < m; i ++){
            if (i + mid - 1 == m) break;
            if (query (0, m - 1, 1, i, i + mid - 1)) continue;
            int xxx = sums1 [mid] + sums2 [i + mid] - sums2 [i];
            if (xxx > ans){
                ans = xxx;
                l1 = 0;
                l2 = i;
            }
        }
        for (int i = k; i < n; i ++){
            if (block [i] < m) upd (0, m - 1, 1, block [i]);
            if (block [i - k] < m) upd (0, m - 1, 1, block [i - k]);
            for (int j = 0; j < m; j ++){
            if (j + mid - 1 == m) break;
            if (query (0, m - 1, 1, j, j + mid - 1)) continue;
            int xxx = sums1 [mid + i - k + 1] - sums1 [i - k + 1] + sums2 [j + mid] - sums2 [j];
            if (xxx > ans){
                ans = xxx;
                l1 = i - k + 1;
                l2 = j;
            }
        }
        }
        if (l == r){
            if (ans == 0) cout << "0\n";
            else cout << ans << '\n' << l1 + 1 << ' ' << l1 + mid << '\n' << l2 + 1 <<' ' << l2 + mid << '\n';
            return 0;
        }
        if (ans == 0){
            r = mid - 1;
        }
        else l = mid;
    }

    return 0;
}
