#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
vector <int> primes;
vector <int> br;
int sz = 1;
bool dali [10000000];
long long tree1 [2500000], tree2 [2500000];
void upd1 (int l, int r, int pos, int qpos, int x){
    if (l == r){
        tree1 [pos] += x;
        return;
    }
    int mid = (l + r) / 2;
    if (qpos <= mid) upd1 (l, mid, 2 * pos, qpos, x);
    else upd1 (mid + 1, r, 2 * pos + 1, qpos, x);
    tree1 [pos] += x;
}
int q1 (int l, int r, int ql, int qr, int pos){
    if (l > qr || r < ql) return 0;
    if (l >= ql && r <= qr) return tree1 [pos];
    int mid = (l + r) / 2;
    return q1 (l, mid, ql, qr, 2 * pos) + q1 (mid + 1, r, ql, qr, 2 * pos + 1);
}
void upd2 (int l, int r, int pos, int qpos, int x){
    if (l == r){
        tree2 [pos] += x;
        return;
    }
    int mid = (l + r) / 2;
    if (qpos <= mid) upd2 (l, mid, 2 * pos, qpos, x);
    else upd2 (mid + 1, r, 2 * pos + 1, qpos, x);
    tree2 [pos] += x;
}
int q2 (int l, int r, int ql, int qr, int pos){
    if (l > qr || r < ql) return 0;
    if (l >= ql && r <= qr) return tree2 [pos];
    int mid = (l + r) / 2;
    return q2 (l, mid, ql, qr, 2 * pos) + q2 (mid + 1, r, ql, qr, 2 * pos + 1);
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (nullptr);

    primes.push_back (2);
    br.push_back (0);
    for (int i = 3; i < 10000000; i += 2){
        if (dali [i]) continue;
        br.push_back (0);
        sz ++;
        primes.push_back (i);
        for (int j = i; j < 10000000; j += i){
            dali [j] = 1;
        }
    }

    char ch;
    while (cin >> ch){
        if (ch == 'a'){
            int a;
            cin >> a;
            auto idx = lower_bound (primes.begin (), primes.end (), a);
            if (idx == primes.end () || *idx != a) continue;
            int pos = idx - primes.begin ();
            br [pos] ++;
            upd1 (0, sz, 1, pos, 1);
            upd2 (0, sz, 1, pos, a);
        }
        if (ch == 'd'){
            int d;
            cin >> d;
            auto idx = lower_bound (primes.begin (), primes.end (), d);
            if (idx == primes.end () || *idx != d) continue;
            int pos = idx - primes.begin ();
            if (br [pos] > 0){
                br [pos] --;
                upd1 (0, sz, 1, pos, -1);
                upd2 (0, sz, 1, pos, -1 * d);
            }
        }
        if (ch == 'c'){
            int l, r;
            cin >> l >> r;
            auto itl = lower_bound (primes.begin (), primes.end (), l);
            auto itr = upper_bound (primes.begin (), primes.end (), r) - 1;
            int ql = itl - primes.begin (), qr = itr - primes.begin ();
            cout << q1 (0, sz, ql, qr, 1) << ' ' << q2 (0, sz, ql, qr, 1) << '\n';
        }
    }

    return 0;
}
