#include<iostream>
#include<map>
#include<set>

using namespace std;

#define endl "\n"

int a[2001],b[2001];
int which[2001];
int prefixa[2001],prefixb[2001];
set<int> Set;
int n,m;

bool possible(int x)
{
    int i,pr;
    set<int> :: iterator it;

    Set.clear();
    Set.insert(m);

    for(i=0;i<x;i++)
        Set.insert(which[i]);

    pr=-1;

    for(it=Set.begin();it!=Set.end();it++)
    {
        if(*it-pr-1>=x)
            return 1;
        pr=*it;
    }

    for(i=x;i<n;i++)
    {
        Set.erase(which[i-x]);
        Set.insert(which[i]);

        pr=-1;

        for(it=Set.begin();it!=Set.end();it++)
        {
            if(*it-pr-1>=x)
            return 1;

            pr=*it;
        }
    }
    return 0;
}

map<int,int>Map;

void initPrefix()
{
    int i;

    prefixa[0]=a[0];
    for(i=1;i<n;i++)
        prefixa[i]=prefixa[i-1]+a[i];

    prefixb[0]=b[0];
    for(i=1;i<m;i++)
        prefixb[i]=prefixb[i-1]+b[i];
}

int findSumA(int l,int r)
{
    if(l==0)
        return prefixa[r];
    return prefixa[r]-prefixa[l-1];
}
int findSumB(int l,int r)
{
    if(l==0)
        return prefixb[r];
    return prefixb[r]-prefixb[l-1];
}

int main ()
{
    int i,j;
    int maxi=0,la,ra,lb,rb;

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n>>m;

    for(i=0;i<n;i++)
        cin>>a[i];
    for(i=0;i<m;i++)
        cin>>b[i];

    for(i=0;i<n;i++)
    {
        Map[a[i]]=i;
        //cout<<a[i]<<" "<<Map[a[i]]<<endl;
    }
    for(i=0;i<n;i++)
        which[i]=-1;
    for(i=0;i<m;i++)
        if(Map.find(b[i])!=Map.end())
            which[Map[b[i]]]=i;

    int l,r,mid;

    l=0;
    r=min(n,m);

    while(l!=r)
    {
        mid=(l+r+1)/2;

        if(possible(mid))
            l=mid;
        else
            r=mid-1;
    }

    if(l==0)
    {
        cout<<"0"<<endl;
        return 0;
    }

    initPrefix();

    int pr,p,t,x=l;
    set<int> :: iterator it;

    Set.clear();
    Set.insert(m);

    for(i=0;i<x;i++)
        Set.insert(which[i]);

    pr=-1;

    for(it=Set.begin();it!=Set.end();it++)
    {
        if(*it-pr-1>=x)
        {
            t=*it;
            for(j=pr+x;j<t;j++)
            {
                p=findSumA(0,x-1)+findSumB(j-x+1,j);\
                //cout<<p<<endl;
                if(p>maxi)
                {
                    maxi=p;
                    la=0;
                    ra=x-1;
                    lb=j-x+1;
                    rb=j;
                }
            }
        }
        pr=*it;
    }

    for(i=x;i<n;i++)
    {
        Set.erase(which[i-x]);
        Set.insert(which[i]);

        pr=-1;

        for(it=Set.begin();it!=Set.end();it++)
        {
            if(*it-pr-1>=x)
            {
                t=*it;
                for(j=pr+x;j<t;j++)
                {
                    //cout<<p<<endl;
                    p=findSumA(i-x+1,i)+findSumB(j-x+1,j);
                    if(p>maxi)
                    {
                        maxi=p;
                        la=i-x+1;
                        ra=i;
                        lb=j-x+1;
                        rb=j;
                    }
                }
            }

            pr=*it;
        }
    }

    cout<<maxi<<endl;
    cout<<la+1<<" "<<ra+1<<endl;
    cout<<lb+1<<" "<<rb+1<<endl;

    return 0;
}
/*
4 6
2 3 4 8
3 2 5 7 1 4
*/
