#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <vector>
#include <stack>
#define MAXN 2048
#define MAXM 2048
using namespace std;
typedef long long ll;
ll n, m;
ll a[MAXN], b[MAXM];
ll ans = -1;
ll l1, r1;
ll l2, r2;
ll cnt = -1;
bool can[750][750][750];
ll sum1[MAXN], sum2[MAXM];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    for (ll i = 1; i <= n; i++)
        cin >> a[i];
    for (ll i = 1; i <= m; i++)
        cin >> b[i];
        for (int i = 1; i <= n; i++)
            sum1[i] = sum1[i-1] + a[i];
        for (int j = 1; j <= m; j++)
            sum2[j] = sum2[j-1] + b[j];
        for (ll i = 1; i <= n; i++)
            for (ll j = 1; j <= m; j++)
            if (a[i] != b[j])
            can[i][j][1] = true;
        for (ll sz = 2; sz <= min(n, m); sz++)
            for (ll i = 1; i + sz - 1 <= n; i++)
            for (ll j = 1; j + sz - 1 <= m; j++)
            if (can[i][j][sz-1] && can[i+1][j+1][sz-1] && can[i][j+1][sz-1] && can[i+1][j][sz-1])
                can[i][j][sz] = true;
            for (ll sz = 1; sz <= min(n, m); sz++)
                for (ll i = 1; i + sz - 1 <= n; i++)
                for (ll j = 1; j + sz - 1 <= m; j++)
                if (can[i][j][sz])
            {
                if (sz > cnt)
                {
                    cnt = sz;
                    ans = sum1[i+sz-1] - sum1[i-1] + sum2[j+sz-1] - sum2[j-1];
                    l1 = i, r1 = i + sz - 1;
                    l2 = j, r2 = j + sz - 1;
                }
                if (sz == cnt && sum1[i+sz-1] - sum1[i-1] + sum2[j+sz-1] - sum2[j-1] > ans)
                {
                    cnt = sz;
                    ans = sum1[i+sz-1] - sum1[i-1] + sum2[j+sz-1] - sum2[j-1];
                    l1 = i, r1 = i + sz - 1;
                    l2 = j, r2 = j + sz - 1;
                }
                if (sz == cnt && sum1[i+sz-1] - sum1[i-1] + sum2[j+sz-1] - sum2[j-1] == ans && (i < l1 || (i == l1 && j < l2)))
                {
                    cnt = sz;
                    ans = sum1[i+sz-1] - sum1[i-1] + sum2[j+sz-1] - sum2[j-1];
                    l1 = i, r1 = i + sz - 1;
                    l2 = j, r2 = j + sz - 1;
                }
            }
        cout << ans << endl;
        cout << l1 << " " << r1 << endl;
        cout << l2 << " " << r2 << endl;
}
