#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <vector>
#include <stack>
#define MAXN 2048
#define MAXM 2048
#define MAXNUM 1000003
using namespace std;
typedef long long ll;
ll n, m;
ll a[MAXN], b[MAXM];
ll ans = -1;
ll l1, r1;
ll l2, r2;
ll ans1 = -1;
bool can(ll sz)
{
    bool is = false;
    for (ll i = 1; i <= n-sz+1; i++)
    {
        set <ll> s;
        ll cnt[MAXNUM];
        memset(cnt, 0, sizeof(cnt));
        ll sum = 0;
        for (ll j = i; j <= i + sz - 1; j++)
        {
            sum += a[j];
            cnt[a[j]]++;
            if (cnt[a[j]] > 1 && s.find(a[j]) == s.end())
                s.insert(a[j]);
        }
        for (ll j = 1; j <= sz; j++)
        {
            sum += b[j];
            cnt[b[j]]++;
            if (cnt[b[j]] > 1 && s.find(b[j]) == s.end())
                s.insert(b[j]);
        }
        if (s.size() == 0)
        {
            is = true;
            if (sz > ans1)
            {
                ans1 = sz;
                ans = sum;
                l1 = i;
                r1 = i + sz - 1;
                l2 = 1;
                r2 = sz;
            }
            if (sz == ans1 && sum > ans)
            {
                ans1 = sz;
                ans = sum;
                l1 = i;
                r1 = i + sz - 1;
                l2 = 1;
                r2 = sz;
            }
            if (sz == ans1 && sum == ans && (i < l1 || (i == l1 && 1 < l2)))
            {
                ans1 = sz;
                ans = sum;
                l1 = i;
                r1 = i + sz - 1;
                l2 = 1;
                r2 = sz;
            }
        }
        for (ll j = 2; j <= m - sz + 1; j++)
    {
        cnt[b[j-1]]--;
            if (cnt[b[j-1]] == 1)
                s.erase(s.find(b[j-1]));
            cnt[b[j+sz-1]]++;
            sum -= b[j-1];
            sum += b[j+sz-1];
            if (cnt[b[j+sz-1]] > 1 && s.find(b[j+sz-1]) == s.end())
                s.insert(b[j+sz-1]);
                if (s.size() == 0)
                  {
                      is = true;
                      if (sz > ans1)
                {
                    ans1 = sz;
                    ans = sum;
                    l1 = i;
                    r1 = i + sz - 1;
                    l2 = j;
                    r2 = j+sz-1;
                }
                if (sz == ans1 && sum > ans)
                {
                    ans1 = sz;
                    ans = sum;
                    l1 = i;
                    r1 = i + sz - 1;
                    l2 = j;
                    r2 = j+sz-1;
                }
                if (sz == ans1 && sum == ans && (i < l1 || (i == l1 && j < l2)))
                {
                    ans1 = sz;
                    ans = sum;
                    l1 = i;
                    r1 = i + sz - 1;
                    l2 = j;
                    r2 = j+sz-1;
                }
            }
        }
    }
    return is;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    for (ll i = 1; i <= n; i++)
        cin >> a[i];
    for (ll i = 1; i <= m; i++)
        cin >> b[i];
    bool is = false;
    for (ll i = 1; i <= n; i++)
        for (ll j = 1; j <= m; j++)
        if (a[i] != b[j])
        is = true;
    if (!is)
    {
        cout << 0 << endl;
        return 0;
    }
    ll l = 1, r = min(n, m);
    while (l <= r)
    {
        int mid = (l + r) / 2;
        if (can(mid) && !can(mid+1)) break;
        if (can(mid)) l = mid + 1;
        else r = mid-1;
    }
    if (ans1 == -1)
        cout << 0 << endl;
    else
    {
        cout << ans << endl;
        cout << l1 << " " << r1 << endl;
        cout << l2 << " " << r2 << endl;
    }
}
