#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <vector>
#include <stack>
#define MAXNUM 10000003
using namespace std;
bool prime[MAXNUM];
multiset <long long> s;
void eratosten()
{
    memset(prime, true, sizeof(prime));
    prime[1] = prime[0] = false;
    for (int i = 2; i <= 10000000; i++)
        if (prime[i])
        for (int j = i * 2; j < MAXNUM; j += i)
        prime[j] = false;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    eratosten();
    char sy;
    while (cin >> sy)
    {
        if (sy == 'a')
        {
            long long num;
            cin >> num;
            if (prime[num])
                s.insert(num);
        }
        else if (sy == 'd')
        {
            long long num;
            cin >> num;
            auto it = s.find(num);
            if (it != s.end())
                s.erase(it);
        }
        else
        {
            long long l, r;
            cin >> l >> r;
            long long cnt = 0, sum = 0;
            for (auto it = lower_bound(s.begin(), s.end(), l); it != s.end() and *it <= r; it++)
            {
                cnt++;
                sum += *it;
            }
            cout << cnt << " " << sum << endl;
        }
    }
}
/*
a 1
a 5
c 5 5
a 4
c 1 50
a 3
d 5
a 7
a 6
a 7
c 3 8
a 10
a 11
a 12
c 8 12
d 11
c 7 11
d 7
d 7
d 7
c 1 100
c 100 200
*/
