#include <iostream>
#include <vector>
#include <string>
using namespace std;
int n, m;
vector <int> v, d;
bool used[100000];

void input()
{
    cin >> n >> m;

    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        v.push_back(x);
    }

    for (int i = 0; i < m; i++)
    {
        int x;
        cin >> x;
        d.push_back(x);
    }
}

bool check(int s1, int s2, int t, long long &sum)
{
    sum = 0;
    for (int i = s1; i < s1 + t; i++)
    {
        used[v[i]] = 1;
        sum += v[i];
    }

    for (int i = s2; i < s2 + t; i++)
        if (used[d[i]])
            return false;

    return true;
}

long long add(int s2, int t)
{
    long long s = 0;
    for (int i = s2; i < s2 + t; i++)
    {
        s += d[i];
    }
    return s;
}

void find()
{
    long long sum;
    long long max1 = -1;
    int l1, r1;
    int l2, r2;

    for (int t = min(m, n); t >= 1; t--)
    {
        for (int s1 = 0; s1 <= n - t; s1++)
            for (int s2 = 0; s2 <= m - t; s2++)
                if (check(s1, s2, t, sum))
                {
                    sum += add(s2, t);
                    if (sum > max1)
                    {
                        max1 = sum;
                        l1 = s1 + 1;
                        r1 = s1 + t;
                        l2 = s2 + 1;
                        r2 = s2 + t;
                    }
                }
        if (max1 != -1)
            break;
    }

    if (max1 == -1)
    {
        cout << 0 << endl;
        return;
    }
    cout << max1 << endl;
    cout << l1 << " " << r1 << endl;
    cout << l2 << " " << r2 << endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    input();
    find();



    return 0;

}
