#include <iostream>
#include <algorithm>
using namespace std;
int nums[10000001];
bool er[10000001];
int sums[10001];
int primes[10001];
int main () {
    ios::sync_with_stdio(0);
    cin.tie(0);
    char ch;
    int x, y, s;
    long long ans1, ans2;
    s=sqrt(10000000);
    for (int i=0;i<=10000000;i++) er[i]=false;
    for (int i=4;i<=10000000;i+=2) er[i]=true;
    er[1]=true;
    for (int i=3;i<=s;i+=2) {
        if (!er[i]) {
            for (int j=i*i;j<=10000000;j+=i*2) {
                er[j]=true;
            }
        }
    }
    while (cin >> ch) {
        if (ch=='a') {
            cin >> x;
            if (!er[x]) {
                nums[x]++;
                sums[x/1000]+=x;
                primes[x/1000]++;
            }
        }
        if (ch=='d') {
            cin >> x;
            if (nums[x]>0 and !er[x]) {
                nums[x]--;
                sums[x/1000]-=x;
                primes[x/1000]--;
            }
        }
        if (ch=='c') {
            cin >> x >> y;
            ans1=ans2=0;
            if (x/1000==y/1000) {
                for (int i=x;i<=y;i++) {
                    if (!er[i] and nums[i]>0) {
                        ans1+=nums[i];
                        ans2+=nums[i]*i;
                    }
                }
            } else {
                for (int i=x;i<(x/1000+1)*1000;i++) {
                    if (!er[i] and nums[i]>0) {
                        ans1+=nums[i];
                        ans2+=nums[i]*i;
                    }
                }
                for (int i=x/1000+1;i<y/1000;i++) {
                    ans1+=primes[i];
                    ans2+=sums[i];
                }
                for (int i=(y/1000)*1000;i<=y;i++) {
                    if (!er[i] and nums[i]>0) {
                        ans1+=nums[i];
                        ans2+=nums[i]*i;
                    }
                }
            }
            cout << ans1 << ' ' << ans2 << '\n';
        }
    }
    return 0;
}
/**
a 1
a 5
c 5 5
a 4
c 1 50
a 3
d 5
a 7
a 6
a 7
c 3 8
a 10
a 11
a 12
c 8 12
d 11
c 7 11
d 7
d 7
d 7
c 1 100
c 100 200
**/
