#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> inline void chkmax(T &x, const T1 &y) { if (x < y) x = y; }
template<class T, class T1> inline void chkmin(T &x, const T1 &y) { if (x > y) x = y; }

const int MAXN = (int)1e7;

multiset<int> bag;

//bool is_simple(int x)
//{
//    if (x < 2)
//        return false;
//    if (x == 2)
//        return true;
//    if (!(x & 1))
//        return false;
//    for (int i = 2; i * i <= x; i++)
//        if (x % i == 0)
                                                                                              //            return false;
//    return true;
//}


bool primes[MAXN + 5];

void calc()
{
    //clock_t time = clock();
    memset(primes, false, sizeof(primes));
    primes[0] = primes[1] = true;
    for (int i = 2; i * i <= MAXN; i++)
        if (!primes[i])
            for (int j = i * i; j <= MAXN; j += i)
                primes[j] = true;
//    time = clock() - time;
//    double d = double(time) / double(CLOCKS_PER_SEC);
//    cout << setprecision(3) << fixed << d << endl;
}

int numbers[MAXN + 5];

void solve()
{
    multiset<int>::iterator it, to;
    bag.clear();
    char ch;
    while (cin >> ch)
    {
        if (ch == 'a')
        {
            int x;
            cin >> x;
            numbers[x]++;
            if (!primes[x])
                bag.insert(x);
        }
        else if (ch == 'd')
        {
            int x;
            cin >> x;
            if (numbers[x] > 0)
            {
                numbers[x]--;
                if (!primes[x])
                    bag.erase(bag.lower_bound(x));
            }
        }
        else
        {
            int x, y;
            cin >> x >> y;
            int cnt = 0;
            long long sum = 0ll;
            to = bag.upper_bound(y);
            for (it = bag.lower_bound(x); it != to; it++)
            {
                int val = *it;
                if ((val >= x) && !(primes[val]))
                {
                    cnt++;
                    sum += (long long)val;
                }
            }
            cout << cnt << ' ' << sum << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    memset(numbers, 0, sizeof(numbers));

    calc();
    solve();

    return EXIT_SUCCESS;
}
